/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 * 
 *  Copyright (C) 2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*
 *  ץå¸⥸塼 ֥ARM-Mѡ
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#define CAST(type, val)	(val)		/* 㥹ȤԤޥ */

#include "kernel_impl.h"
#include "arm_m.h"


	.text

/*
 *  
 */
	.global		intnest

/*
 *  CPU㳰ȥ
 *
 *  ߥȥȽƤƱμबۤʤ뤿ᡤ
 *  ʬƤ롥
 */
	.align 2
	.syntax unified
	.code 16
	.global exc_entry
	.type exc_entry, function
exc_entry:
	/*
	 *  㳰/ߤȯȡȯ˥ƥ֤ʥå˥
	 *  å쥸¸롥
	 *  Ƥ˲äơCPU㳰ϥɥؤξȤơbasepri ͤȡ
	 *  EXC_RETURNξä¸롥basepriͤϡCPU㳰
	 *  ꥿˳ͥ٥ޥͤ򸵤᤹ˤѤ롥
	 *
	 *   -----------
	 *  | EXC_RETURN|  
	 *   -----------
	 *  |  basepri  |  
	 *   -----------
	 *  |    R0     |  
	 *   -----------
	 *  |    R1     |
	 *   -----------
	 *  |    R2     |
	 *   -----------
	 *  |    R3     |
	 *   -----------
	 *  |    R12    |
	 *   -----------
	 *  |    LR     |
	 *   -----------
	 *  |    PC     |
	 *   -----------
	 *  |   xPSR    |
	 *   -----------
	 *
	 */

	/*
	 *  ȯγͥ٥ޥ򥹥å¸뤿
	 */
	mrs   r2, basepri			/* baepriͤ */
	push  {r2}					/* ȯγͥ٥ޥѤ */
	push  {lr}					/* EXC_RETURN Ѥ			  */ 
	mov   r0, sp				/* CPU㳰ϥɥؤΰȤʤ */
	
	ldr   r1 , =lock_flag		/* CPUåե饰¸ */
	ldr   r1 , [r1]
	push  {r1}
	
	/* ߥͥȿβû */
	ldr r1 , =intnest
	ldr r3 , [r1]
	add r3 , #1
	str r3 , [r1]

	/*
	 *  ̽
	 */
exc_entry_2:
	mrs   r3, ipsr               /* ϥɥ饢ɥ쥹 */
	ldr   r1, =_kernel_exc_tbl
	ldr   r2, [r1, r3, lsl #2]
	
#ifdef LOG_EXC_ENTER
	push  {r0, r2, r3}
	mov   r0, r3                 /* 㳰ֹѥ᡼  */
	bl    log_exc_enter          /* log_exc_enterƤӽФ */
	pop   {r0, r2, r3}
#endif /* LOG_EXC_ENTER */

#ifdef LOG_EXC_LEAVE
	push  { r3 }                   /* 㳰ֹ򥹥å    */
#endif /* LOG_EXC_LEAVE */

	/*
	 *  CPU㳰ϥɥθƤӽФ
	 */
	blx   r2

	/* CPUåե饰򸵤᤹ */
	pop   {r0}
	ldr   r1 , =lock_flag
	str   r0 , [r1]
	
#ifdef LOG_EXC_LEAVE
	pop   { r0 }                   /* 㳰ֹ        */
	bl    log_exc_leave          /* log_exc_leaveƤӽФ */
#endif /* LOG_EXC_LEAVE */
	
	b     ret_exc


/*
 *  ߥȥ
 */
	.align 2
	.syntax unified
	.code 16
	.global int_entry
	.type int_entry, function
int_entry:
	/*
	 *	ȯγͥ٥ޥ򥹥å¸뤿
	 */
	mrs   r2, basepri			  /* baepriͤ */
	push  {r2}					 /* ȯγͥ٥ޥѤ */
	push  {lr}					 /* EXC_RETURN Ѥ			  */ 
	mov   r0, sp				 /* ̤γߤȯξȤ */
	
	/*
	 *	̽
	 */
int_entry_2:
	/* ߥͥȿβû */
	ldr r1 , =intnest
	ldr r3 , [r1]
	add r3 , #1
	str r3 , [r1]
	
	mrs   r3, ipsr				 /* ϥɥ饢ɥ쥹 */
	ldr   r1, =_kernel_exc_tbl
	ldr   r2, [r1, r3, lsl #2]

#ifdef LOG_INH_ENTER
	push  {r0,r2,r3}
	mov   r0, r3                 /* ֹѥ᡼  */
	bl    log_inh_enter          /* log_inh_enterƤӽФ */
	pop   { r0,r2,r3 }
#endif /* LOG_INH_ENTER */

#ifdef LOG_INH_LEAVE
	push  { r3 }                   /* ֹ򥹥å    */
#endif /* LOG_INH_LEAVE */

	/*
	 *  CPU㳰ϥɥθƤӽФ
	 */
	blx   r2
	
#ifdef LOG_INH_LEAVE
	pop   { r0 }                   /* ֹ        */
	bl    log_inh_leave          /* log_inh_leaveƤӽФ */
#endif /* LOG_INH_LEAVE */

/*
 *  /㳰и
 *
 *  ret_exc/ret_intϡCPU㳰/ߥϥɥ餫äľ˼¹Ԥ
 *  롼Ǥ롥
 */
ret_exc:
ret_int:
	/*
	 *  ߥå֤Ȥ롥λǤϡCPUå֤ˤϤʤʤ
	 * baseprilock_flagsaved_iipmϹʤˡ
	 *
	 *  ߥå֤ȤΤϡΥƥȤΥåȡ
	 *  褬󥿥ƥȤǤäΥ꥿򥢥ȥߥå
	 *  ˹ԤǤ롥bsepriCPUåͤˤ뤳ȤǤ⥢ȥߥ
	 *  ʥåϲǽǤ뤬ߤ꥿󤷤Ƥ⡤
	 *  basepri ƤϸʤᡤѤ뤳ȤǤʤ 
	 *  FAULTMASKϡߤΥ꥿ˤäơ'0'˥
	 *  롥
	 */
	cpsid f
	
	/*
	 *  ΥƥȤȽ
	 * 
	 *  intnest0ɤȽǤ
	 *  
	 */
	/* ߥͥȿθ */
	ldr r1 , =intnest
	ldr r3 , [r1]
	add r3 , #-1
	str r3 , [r1]
	
	cmp   r3 , #0
	beq   ret_int_2
	
	/*
	 *  ܤγߤνи
	 */
ret_int_1:
	/*
	 *  ˤϳߥå֡FAULTMASKåȡˤ줿֤롥
	 *  Thread⡼ɤΥ꥿ˤ꼫ưŪ˳ߥå֤ˤʤ롥
	 *  ͥ٥ޥϳ˾֤᤹
	 */ 
	pop		{ r2 }
	pop		{ r1 }
	msr   basepri, r1			  /* ͥ٥ޥ˾֤ */
	bx	  r2					  /* ꥿ */
	
ret_int_2:
	ldr   r0, =reqflg             /* reqflgfalseʤ餽Τޤ */
	ldr   r1, [r0]
	cmp   r1 , #0
	beq    ret_int_1           /* falseʤret_int_1           */
ret_int_3:
	mov   r1, #0                   /* reqflgfalse */
	str   r1, [r0]
	
	/*
	 *  CPUå֤˰ܹԤ롥
	 *
	 *  ͥδγߤػߤ褦basepriꤷ
	 *  lock_flag򹹿롥
	 *  λCPUå֤ȤΤϡdispatcherʬ
	 *  CPUå֤ˤʤäƤɬפ뤿Ǥ롥
     *  ʤνθ塤Thread⡼ɤؤΰܹԽԤʤᡤ
     *  å(FAULTMASK"1")ݻ롥
	 */
	ldr   r1, =IIPM_LOCK		  /* CPUå */ 
	msr   basepri, r1
	mov   r1, #0x01 			  /* lock_flag  true */
	ldr   r0, =lock_flag 
	str   r1, [r0]
	
	/*
	 *  lrФٱǥѥåκݤˤȤᡤ
	 *  åݥ󥿤ʤ
	 */
	
	ldr   r2 , [sp]
	
	/*
	 *  Thread⡼ɤذܹԤ롥
	 *
	 *  dispatchercall_texrnƤӽФϡThread⡼ɤǤɬ
	 *  פ뤿ᡤPSPå˥ߡ㳰ե졼֤ơ
	 *  Ū˳ߥϥɥ餫꥿󤹤롥
	 *  ꥿ƱFAULTMASKưŪ˥ꥢ졤ͥ
	 *  ߤĤ롥
	 */
	ldr   r0, =ret_int_4		  /* PC   */
	ldr   r1, =EPSR_T			  /* xPSR(TӥåȤ'1'Ǥɬפ) */
	stmfd sp!, {r0-r1}			  /* ߡե졼򥹥åѤ	*/
	sub   sp, #(EXC_FRAME_SIZE - (4*2)) /* r0-r3,r12,lrƤꤹɬפʤ */
	bx	  r2					  /* Thread⡼ɤذܹ */
    
ret_int_4:
	bl    search_schedtsk		/* ǵư줿¹ */
	bl    run_task
ret_int_r:
	svc   0 				   /* SVCθƤӽФ */
	
/*
 *  ٱǥѥå˰Ū˳
 *  ƥȤ˰ܹԤ뤿SVCϥɥ
 */

	.align	2
	.thumb
	.thumb_func
	.globl kernel_svc_handler
kernel_svc_handler:
	/*
	 *  ߽Υ꥿ˤꡤCPUå֤˰ܹԤ
	 *  롥
	 */
	cpsid f 								/* ߥå֤ */
	ldr		r2 , [ sp , #(EXC_FRAME_SIZE) ]	/* lr򥹥å	*/
	add		sp, #EXC_FRAME_SIZE + 8			/* åΤƤ	*/
	mov		r0, #0
	ldr		r1, =lock_flag					/* CPUå֤ */
	str		r0, [r1]
	msr		basepri , r0 
	bx		r2								/* ꥿	  */

/*
 *  ǥѥåư
 */
	.align	2
	.thumb
	.thumb_func
	.globl start_dispatch
start_dispatch:
	/*
	 *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
	 * ʳߥå֤ƱˤǸƤӽФ롥ޤߥ⡼ɡ
	 *  ƥȤƱˤǸƤӽФ뤳ȤꤷƤ롥
	 *
	 *  prc_initializeǡlock_flagtrueˡsaved_iipmIIPM_ENAALL
	 *  Ƥ뤿ᡤͥγߤĤ뤳Ȥǡ
	 *  CPUå֡ʥǥΡ˳ͥ٥ޥ֤ˤʤ롥
	 *  ޤtask_initializedisdspfalse˽Ƥ뤿ᡤǥ
	 *  ѥåľ֤ˤʤäƤ롥
	 */
	ldr   r0,=istkpt              /* MSP   */
	ldr   r1,[r0]                 /* start_dispatchƤӽФ˸ƤӽФѤ */
	msr   msp, r1                 /* ѤƤ뤿             */
	ldr   r1, =IIPM_LOCK          /* ͥγߤػ */
	msr   basepri, r1 
	cpsie f                       /* ͥγߤ */
	b	  dispatcher

/*
 *  ͥνλθƽФ
 *
 *  å󥿥ƥѤڤؤ
 *  
 */
	.text
	.syntax unified
	.code 16
	.globl call_exit_kernel
	.type call_exit_kernel, function
call_exit_kernel:
	b     exit_kernel       /* ͥνλƤ */


/*
 *  Ԥ
 */
	.text
	.syntax unified
	.code 16
	.globl sil_dly_nse
	.type sil_dly_nse, function
sil_dly_nse:
	sub   r0, r0, #SIL_DLY_TIM1
	cmp   r0, #0
	bgt   sil_dly_nse1
	mov   pc, lr
sil_dly_nse1:
	sub   r0, r0, #SIL_DLY_TIM2
	cmp   r0, #0
	bgt   sil_dly_nse1
	mov   pc, lr
