/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010-2012 by Meika Sugimoto
 *  Copyright (C) 2015 by Naoki Saito
 *              Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 */

/*
 *		ꥢ륤󥿥եɥ饤
 */

#include <kernel.h>
#include "target_syssvc.h"
#include "target_serial.h"
#include "serial.h"
#include "kernel_cfg.h"

/*
 *  ХåեΥǥեͤȥХåե
 */
#ifndef SERIAL_RCV_BUFSZ1
#define	SERIAL_RCV_BUFSZ1	64			/* ݡ1μХåե */
#endif /* SERIAL_RCV_BUFSZ1 */

#ifndef SERIAL_SND_BUFSZ1
#define	SERIAL_SND_BUFSZ1	256			/* ݡ1Хåե */
#endif /* SERIAL_SND_BUFSZ1 */

static char	rcv_buffer1[SERIAL_RCV_BUFSZ1];
static char	snd_buffer1[SERIAL_SND_BUFSZ1];

#if TNUM_PORT >= 2						/* ݡ2˴ؤ */

#ifndef SERIAL_RCV_BUFSZ2
#define	SERIAL_RCV_BUFSZ2	64			/* ݡ2μХåե */
#endif /* SERIAL_RCV_BUFSZ2 */

#ifndef SERIAL_SND_BUFSZ2
#define	SERIAL_SND_BUFSZ2	64			/* ݡ2Хåե */
#endif /* SERIAL_SND_BUFSZ2 */

static char	rcv_buffer2[SERIAL_RCV_BUFSZ2];
static char	snd_buffer2[SERIAL_SND_BUFSZ2];

#endif /* TNUM_PORT >= 2 */

#if TNUM_PORT >= 3						/* ݡ3˴ؤ */

#ifndef SERIAL_RCV_BUFSZ3
#define	SERIAL_RCV_BUFSZ3	64			/* ݡ3μХåե */
#endif /* SERIAL_RCV_BUFSZ3 */

#ifndef SERIAL_SND_BUFSZ3
#define	SERIAL_SND_BUFSZ3	64			/* ݡ3Хåե */
#endif /* SERIAL_SND_BUFSZ3 */

static char	rcv_buffer3[SERIAL_RCV_BUFSZ3];
static char	snd_buffer3[SERIAL_SND_BUFSZ3];

#endif /* TNUM_PORT >= 3 */

/*
 *  ꥢݡȽ֥å
 */
typedef struct serial_port_initialization_block {
	uint_t	rcv_bufsz;		/* Хåե */
	char	*rcv_buffer;	/* Хåե */
	uint_t	snd_bufsz;		/* Хåե */
	char	*snd_buffer;	/* Хåե */
} SPINIB;

static const SPINIB spinib_table[TNUM_PORT] = {
	{ SERIAL_RCV_BUFSZ1, rcv_buffer1,
	  SERIAL_SND_BUFSZ1, snd_buffer1 },
#if TNUM_PORT >= 2
	{ SERIAL_RCV_BUFSZ2, rcv_buffer2,
	  SERIAL_SND_BUFSZ2, snd_buffer2 },
#endif /* TNUM_PORT >= 2 */
#if TNUM_PORT >= 3
	{ SERIAL_RCV_BUFSZ3, rcv_buffer3,
	  SERIAL_SND_BUFSZ3, snd_buffer3 },
#endif /* TNUM_PORT >= 3 */
};

/*
 *  ꥢݡȴ֥å
 */
typedef struct serial_port_control_block {
	const SPINIB *p_spinib;		/* ꥢݡȽ֥å */
	SIOPCB	*p_siopcb;			/* ꥢI/Oݡȴ֥å */
	bool_t	openflag;			/* ץѤߥե饰 */
	bool_t	errorflag;			/* 顼ե饰 */
	uint_t	ioctl;				/* ư */

	uint_t	rcv_read_ptr;		/* ХåեɽФݥ */
	uint_t	rcv_write_ptr;		/* Хåեߥݥ */
	uint_t	rcv_count;			/* Хåեʸ */

	uint_t	snd_read_ptr;		/* ХåեɽФݥ */
	uint_t	snd_write_ptr;		/* Хåեߥݥ */
	uint_t	snd_count;			/* Хåեʸ */
} SPCB;

static SPCB	spcb_table[TNUM_PORT];

/*
 *  ꥢݡID饷ꥢݡȴ֥åФΥޥ
 */
#define INDEX_PORT(portid)	((uint_t)((portid) - 1))
#define get_spcb(portid)	(&(spcb_table[INDEX_PORT(portid)]))

/*
 *  ݥ󥿤Υ󥯥
 */
#define INC_PTR(ptr, bufsz)		{ if (++(ptr) == (bufsz)) { (ptr) = 0; }}

/*
 *  ӥƽФޥ
 *
 *  ӥƽФޤ༰expɾͤ顼͡ˤξ
 *  ˤϡercercd_expɾͤerror_exitgoto롥
 */
#define SVC(exp, ercd_exp) \
				{ if ((exp) < 0) { ercd = (ercd_exp); goto error_exit; }}

/*
 *  E_SYS顼
 */
static ER
gen_ercd_sys(SPCB *p_spcb)
{
	p_spcb->errorflag = true;
	return(E_SYS);
}


/*
 *  ꥢ륤󥿥եɥ饤Фν롼
 */
void
serial_initialize(intptr_t exinf)
{
	uint_t	i;
	SPCB	*p_spcb;

	for (i = 0; i < TNUM_PORT; i++) {
		p_spcb = &(spcb_table[i]);
		p_spcb->p_spinib = &(spinib_table[i]);
		p_spcb->openflag = false;
	}
}

/*
 *  ꥢ륤󥿡եɥ饤Фνλ롼
 */

void
serial_terminate(intptr_t exinf)
{
	uint_t	i;
	SPCB	*p_spcb;
	
	/* Хåե˻ĤäƤƤʸϤ */
	for (i = 0; i < TNUM_PORT; i++) {
		p_spcb = &(spcb_table[i]);

		while(p_spcb->snd_count != 0U)
		{
			if(sio_snd_chr(p_spcb->p_siopcb,
					p_spcb->p_spinib->snd_buffer[p_spcb->snd_read_ptr]) == true)
			{
				INC_PTR(p_spcb->snd_read_ptr, p_spcb->p_spinib->snd_bufsz);
				p_spcb->snd_count--;
			}
		}
	}

}

/*
 *  ꥢݡȤΥץʥӥ
 */
ER
serial_opn_por(ID portid)
{
	SPCB	*p_spcb;
	ER		ercd;

	if (sns_dpn()) {				/* ƥȤΥå */
		return(E_CTX);
	}
	if (!(1 <= portid && portid <= TNUM_PORT)) {
		return(E_ID);				/* ݡֹΥå */
	}
	p_spcb = get_spcb(portid);

	SVC(dis_dsp(), gen_ercd_sys(p_spcb));
	if (p_spcb->openflag) {			/* ץѤߤΥå */
		ercd = E_OBJ;
	}
	else {
		/*
		 *  ѿν
		 */
		p_spcb->ioctl = (IOCTL_ECHO | IOCTL_CRLF);

		p_spcb->rcv_read_ptr = p_spcb->rcv_write_ptr = 0U;
		p_spcb->rcv_count = 0U;

		p_spcb->snd_read_ptr = p_spcb->snd_write_ptr = 0U;
		p_spcb->snd_count = 0U;

		/*
		 *  ʹߡߤػߤ롥
		 */
		if (loc_cpu() < 0) {
			ercd = E_SYS;
			goto error_exit_enadsp;
		}

		/*
		 *  ϡɥ¸Υץ
		 */
		p_spcb->p_siopcb = sio_opn_por(portid, (intptr_t) p_spcb);

		/*
		 *  ΥХåĤ롥
		 */
		sio_ena_cbr(p_spcb->p_siopcb, SIO_RDY_RCV);
		p_spcb->openflag = true;
		p_spcb->errorflag = false;

		if (unl_cpu() < 0) {
			p_spcb->errorflag = true;
			ercd = E_SYS;
			goto error_exit_enadsp;
		}
		ercd = E_OK;
	}

  error_exit_enadsp:
	SVC(ena_dsp(), gen_ercd_sys(p_spcb));

  error_exit:
	return(ercd);
}

/*
 *  ꥢݡȤΥʥӥ
 */
ER
serial_cls_por(ID portid)
{
	SPCB	*p_spcb;
	ER		ercd;
	bool_t	eflag = false;

	if (sns_dpn()) {				/* ƥȤΥå */
		return(E_CTX);
	}
	if (!(1 <= portid && portid <= TNUM_PORT)) {
		return(E_ID);				/* ݡֹΥå */
	}
	p_spcb = get_spcb(portid);

	SVC(dis_dsp(), gen_ercd_sys(p_spcb));
	if (!(p_spcb->openflag)) {		/* ץѤߤΥå */
		ercd = E_OBJ;
	}
	else {
		/*
		 *  ϡɥ¸Υ
		 */
		if (loc_cpu() < 0) {
			eflag = true;
		}
		sio_cls_por(p_spcb->p_siopcb);
		p_spcb->openflag = false;
		if (unl_cpu() < 0) {
			eflag = true;
		}
		
		/*
		 *  顼ɤ
		 */
		if (eflag) {
			ercd = gen_ercd_sys(p_spcb);
		}
		else {
			ercd = E_OK;
		}
	}
	SVC(ena_dsp(), gen_ercd_sys(p_spcb));

  error_exit:
	return(ercd);
}

/*
 *  ꥢݡȤؤʸ
 *
 *  p_spcbǻꤵ륷ꥢI/OݡȤФơʸc롥ʸ
 *  쥸ˤ줿ˤtrue֤Ǥʤˤϡ
 *  쥸ȤΤ륳ХåؿĤfalse֤
 *  δؿϡCPUå֤ǸƤӽФ롥
 */
Inline bool_t
serial_snd_chr(SPCB *p_spcb, char c)
{
	if (sio_snd_chr(p_spcb->p_siopcb, c)) {
		return(true);
	}
	else {
		sio_ena_cbr(p_spcb->p_siopcb, SIO_RDY_SND);
		return(false);
	}
}

/*
 *  ꥢݡȤؤ1ʸ
 *  ꤵ줿ʸߤ.
 *  ǥХؤޤϥХåե˶ǼǤ false, 
 *  ХåեեǳǼǤʤä true ֤
 *  ʳΥ顼ȯ ER Υ顼ɤ֤
 */
static ER_BOOL
serial_wri_chr(SPCB *p_spcb, char c)
{
	bool_t	buffer_full;
	ER		ercd, rercd;

	/*
	 *  LFCR롥
	 *  1ʸʲζʤϥХåեեȤߤʤʤ
	 */
	if (c == '\n' && (p_spcb->ioctl & IOCTL_CRLF) != 0U) {
		if(p_spcb->snd_count + 1U < p_spcb->p_spinib->snd_bufsz) {
			SVC(rercd = serial_wri_chr(p_spcb, '\r'), rercd);
		}
		else {
			return (ER_BOOL) true;
		}
	}

	SVC(loc_cpu(), gen_ercd_sys(p_spcb));
	if ((p_spcb->snd_count == 0U) && serial_snd_chr(p_spcb, c)) {
		/*
		 *  ꥢI/OǥХ쥸ʸ뤳Ȥ
		 *  硥
		 */
		buffer_full = false;
	}
	else {
		/*
		 *  СХåեʸ롥
		 *  ʤ硤ʤ
		 */
		if(p_spcb->snd_count < p_spcb->p_spinib->snd_bufsz) {
			p_spcb->p_spinib->snd_buffer[p_spcb->snd_write_ptr] = c;
			INC_PTR(p_spcb->snd_write_ptr, p_spcb->p_spinib->snd_bufsz);
			p_spcb->snd_count++;
			buffer_full = false;
		}
		else {
			buffer_full = true;
		}
	}

	SVC(unl_cpu(), gen_ercd_sys(p_spcb));
	ercd = (ER_BOOL) buffer_full;

  error_exit:
	return(ercd);
}

bool_t
serial_rcvbuf_empty(SPCB *p_spcb)
{
	return (p_spcb->rcv_count == 0u);
}

/*
 *  ꥢݡȤؤʸʥӥ
 */
ER_UINT
serial_wri_dat(ID portid, const char *buf, uint_t len)
{
	SPCB	*p_spcb;
	bool_t	buffer_full;
	uint_t	wricnt = 0U;
	ER		ercd, rercd;

	if (sns_dpn()) {				/* ƥȤΥå */
		return(E_CTX);
	}
	if (!(1 <= portid && portid <= TNUM_PORT)) {
		return(E_ID);				/* ݡֹΥå */
	}

	p_spcb = get_spcb(portid);
	if (!(p_spcb->openflag)) {		/* ץѤߤΥå */
		return(E_OBJ);
	}
	if (p_spcb->errorflag) {		/* 顼֤Υå */
		return(E_SYS);
	}
	
	/*
	 *  len ޤ1ʸߤ롥
	 *  ǥХåեեˤʤäǤ롥
	 */
	SVC((rercd = dis_dsp()) , rercd);
	for(wricnt = 0U; wricnt < len; wricnt++) {
		SVC(rercd = serial_wri_chr(p_spcb, *buf++), rercd);
		buffer_full = (bool_t)rercd;
		if(buffer_full) {
			break;
		}
	}
	SVC((rercd = ena_dsp()) , rercd);
	
	ercd = E_OK;
  error_exit:
	return(wricnt > 0U ? (ER_UINT) wricnt : ercd);
}

/*
 *  ꥢݡȤ1ʸ
 *  ʸμߤ.
 *  Хåե˥ǡ¸ߤǤ false, 
 *  ХåեǼǤʤä true ֤
 *  ʳΥ顼ȯ ER Υ顼ɤ֤
 */
static ER_BOOL
serial_rea_chr(SPCB *p_spcb, char *p_c)
{
	bool_t	buffer_empty;
	ER		ercd;

	SVC(loc_cpu(), gen_ercd_sys(p_spcb));

	/*
	 *  ǡ¸ߤСХåեʸФ
	 *  ʤмФʤ
	 */
	if(p_spcb->rcv_count > 0U) {
		*p_c = p_spcb->p_spinib->rcv_buffer[p_spcb->rcv_read_ptr];
		INC_PTR(p_spcb->rcv_read_ptr, p_spcb->p_spinib->rcv_bufsz);
		p_spcb->rcv_count--;
		buffer_empty = false;
	}
	else {
		buffer_empty = true;
	}
	
	SVC(unl_cpu(), gen_ercd_sys(p_spcb));
	ercd = (ER_BOOL) buffer_empty;

  error_exit:
	return(ercd);
}

/*
 *  ꥢݡȤʸʥӥ
 */
ER_UINT
serial_rea_dat(ID portid, char *buf, uint_t len)
{
	SPCB	*p_spcb;
	bool_t	buffer_empty;
	uint_t	reacnt = 0U;
	char	c = '\0';		/* ѥηٹ޻ߤ뤿˽ */
	ER		ercd, rercd;

	if (sns_dpn()) {				/* ƥȤΥå */
		return(E_CTX);
	}
	if (!(1 <= portid && portid <= TNUM_PORT)) {
		return(E_ID);				/* ݡֹΥå */
	}

	p_spcb = get_spcb(portid);
	if (!(p_spcb->openflag)) {		/* ץѤߤΥå */
		return(E_OBJ);
	}
	if (p_spcb->errorflag) {		/* 顼֤Υå */
		return(E_SYS);
	}
	
	/*
	 *  len ޤǼߤ롥
	 *  Хåեɤ߽ФʤäǤ
	 */
	SVC((rercd = dis_dsp()) , rercd);
	for(reacnt = 0U; reacnt < len; reacnt++) {
		SVC(rercd = serial_rea_chr(p_spcb, &c), rercd);
		buffer_empty = (bool_t)rercd;

		if(buffer_empty) {
			break;
		}
		else {
			/*
			 *  Хå
			 */
			if ((p_spcb->ioctl & IOCTL_ECHO) != 0U) {
				SVC(rercd = serial_wri_chr(p_spcb, c), rercd);
			}
			*buf++ = c;
		}
	}
	SVC((rercd = ena_dsp()) , rercd);
	
	ercd = E_OK;
  error_exit:
	return(reacnt > 0U ? (ER_UINT) reacnt : ercd);
}

/*
 *  ꥢݡȤʥӥ
 */
ER
serial_ctl_por(ID portid, uint_t ioctl)
{
	SPCB	*p_spcb;

	if (sns_dpn()) {				/* ƥȤΥå */
		return(E_CTX);
	}
	if (!(1 <= portid && portid <= TNUM_PORT)) {
		return(E_ID);				/* ݡֹΥå */
	}

	p_spcb = get_spcb(portid);
	if (!(p_spcb->openflag)) {		/* ץѤߤΥå */
		return(E_OBJ);
	}
	if (p_spcb->errorflag) {		/* 顼֤Υå */
		return(E_SYS);
	}

	p_spcb->ioctl = ioctl;
	return(E_OK);
}

/*
 *  ꥢݡȤǽХå
 */
void
sio_irdy_snd(intptr_t exinf)
{
	SPCB	*p_spcb;

	p_spcb = (SPCB *) exinf;

	if (p_spcb->snd_count > 0U) {
		/*
		 *  Хåե椫ʸФ롥
		 */
		(void) sio_snd_chr(p_spcb->p_siopcb,
					p_spcb->p_spinib->snd_buffer[p_spcb->snd_read_ptr]);
		INC_PTR(p_spcb->snd_read_ptr, p_spcb->p_spinib->snd_bufsz);
		p_spcb->snd_count--;
	}
	else {
		/*
		 *  ٤ʸʤϡǽХåػߤ롥
		 */
		sio_dis_cbr(p_spcb->p_siopcb, SIO_RDY_SND);
	}
}

/*
 *  ꥢݡȤμΥХå
 */
void
sio_irdy_rcv(intptr_t exinf)
{
	SPCB	*p_spcb;
	char	c;
	
	p_spcb = (SPCB *) exinf;
	c = (char) sio_rcv_chr(p_spcb->p_siopcb);
	
	if (p_spcb->rcv_count != p_spcb->p_spinib->rcv_bufsz) {
		/*
		 *  ʸХåե롥
		 *  Хåեեξ硤ʸΤƤ롥
		 */
		p_spcb->p_spinib->rcv_buffer[p_spcb->rcv_write_ptr] = c;
		INC_PTR(p_spcb->rcv_write_ptr, p_spcb->p_spinib->rcv_bufsz);
		p_spcb->rcv_count++;
	}
}

/*
 *  ꥢ륤󥿥եɥ饤Ф̤ʸμФ
 */
bool_t
serial_get_chr(ID portid, char *p_c)
{
	SPCB	*p_spcb;

	if (1 <= portid && portid <= TNUM_PORT) {	/* ݡֹΥå */
		p_spcb = get_spcb(portid);
		if (p_spcb->openflag) {					/* ץѤߤΥå */
			if (p_spcb->snd_count > 0U) {
				*p_c = p_spcb->p_spinib->snd_buffer[p_spcb->snd_read_ptr];
				INC_PTR(p_spcb->snd_read_ptr, p_spcb->p_spinib->snd_bufsz);
				p_spcb->snd_count--;
				return(true);
			}
		}
	}
	return(false);
}
