/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012 Meika Sugimoto
 *  Copyright (C) 2015 by Naoki Saito
 *              Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*
 * åȰ¸⥸塼(CQ-FRM-FM3)
 */
#include "kernel_impl.h"
#include <sil.h>
#include "target_serial.h"
#include "target_syssvc.h"

/*
 * åȥƥΥϡɥ񸻤
 */
#include "cq_frm_fm3.h"


/*
 * åȰ¸
 */
void target_initialize(void)
{
	/*
	 *  ץå¸ν
	 */
	prc_initialize();

	/*
	 *  ڥե
	 */
	
	/*
	 *  ϡɥWDT̵
	 */
	sil_wrw_mem((void *)WDG_LCK , WDG_UNLOCK_VAL);
	sil_wrw_mem((void *)WDG_LCK , ~WDG_UNLOCK_VAL);
	sil_wrw_mem((void *)WDG_CTL , (WDG_RESDIS | WDG_RESINTDIS));
	
	/*
	 *  I/OݡȤν
	 */
#if (SIO_PORTID == 1)
	/* PFR */
	
	/* MFS(RX,TX) CH0 */
	sil_andw((void *)EPFR7 , ~(0x03 << 2));	/* SIN0_0 , SOT0_0 */
	sil_orw((void *)EPFR7 , (0x01 << 6));	/* SIN0_0 , SOT0_0 */
	
	/* P21(SIN),P22(SOT) */
	sil_orw((void *)PFR2 , (1 << 1) | (1 << 2));
	sil_andw((void *)ADE , ~(1 << 31));

#elif (SIO_PORTID == 2)
	/* USART2(RX,TX) CH2 */
	sil_andw((void *)EPFR8 , ~(0x03 << 6));	/* SIN4_2 */
	sil_orw((void *)EPFR8 , (0x03 << 6));	/* SIN4_2 , SOT4_2 */
	
	/* PD2(SIN),PD3(SOT) */
	sil_orw((void *)PFR0 , (1 << 5) | (1 << 6));
	
#endif

	/*
	 *  ХʡѤΥꥢ
	 */
	
	target_low_output_init(SIO_PORTID);
	sil_dly_nse(10 * 1000 * 1000);
	
	/* LEDݡ */
	sil_andw((void *)PFRF , ~BITMAP_3);
	sil_orw((void *)PDDRF , BITMAP_3);
	sil_andw((void *)PDORF , ~BITMAP_3);
	
}

/*
 * åȰ¸ λ
 */
void target_exit(void)
{
	/* ץå¸νλ */
	prc_terminate();
}

/*
 * ƥ٥ϤΤʸ
 */
void target_fput_log(char c)
{
	if (c == '\n') {
		sio_pol_snd_chr('\r', SIO_PORTID);
	}
	sio_pol_snd_chr(c, SIO_PORTID);
}


