/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012 by Meika Sugimoto
 *  Copyright (C) 2015 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*
 * åȰ¸֥CQ-FRM-FM3ѡ
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val)			(val)
#define ULONG_C(val)		(val)
#include "kernel_impl.h"
#include "cq_frm_fm3.h"

/*
 * ٥ΥåȰ¸ν
 *
 * ˸ƤӽФ
 */

	.globl	hardware_init_hook

	.text
	.align 2
	.syntax unified
	.code 16
	.thumb
	.type	hardware_init_hook, function
hardware_init_hook:
	/* ƥХåΥץꥹ */
	ldr	r0 , =#BSC_PSR					/* ١å(1ʬ) */
	mov	r1 , #BSC_CLK_DIV_1
	str	r1 , [r0]
	
	ldr	r0 , =#APBC0_PSR				/* APB0(8ʬ) */
	mov	r1 , #APB_CLK_DIV_8
	str	r1 , [r0]
	
	ldr	r0 , =#APBC1_PSR				/* APB1(8ʬ) */
	mov	r1 , #(APB_CLK_DIV_8 | APBC_EN | APBC_RESET)
	str	r1 , [r0]
	mov	r1 , #(APB_CLK_DIV_8 | APBC_EN)
	str	r1 , [r0]
	
	ldr	r0 , =#APBC2_PSR				/* APB2(8ʬ) */
	mov	r1 , #(APB_CLK_DIV_8 | APBC_EN | APBC_RESET)
	str	r1 , [r0]
	mov	r1 , #(APB_CLK_DIV_8 | APBC_EN)
	str	r1 , [r0]
	
	ldr	r0 , =#INT_CLR		/* INT_CLRΥꥢ */
	mov	r1 , #(INT_CLL_MCS | INT_CLL_SCS | INT_CLL_PCS | INT_CLL_FCS)
	str	r1 , [r0]
	
	/* ᥤ󥯥åȯԤߤ */
	ldr	r0 , =#CSW_PSR
	mov	r1 , #PSW_TMR_MOWT_CONF12
	str	r1 , [r0]
	
	/* ᥤ󥯥åϰԤͭ */
	ldr	r0 , =#INT_ENR
	mov	r1 , #INT_CLL_MCS
	str	r1 , [r0]
	
	/* ᥤ󥯥åư */
	ldr	r0 , =#SCM_CTL
	ldr	r1 , [r0]
	and r1 , #SCM_CTL_MOSCE
	str	r1 , [r0]
	
	/* ᥤ󥯥åԤ */
	ldr	r0 , =#SCM_STR
  wait_main_clock_stable:
	ldr	r1 , [r0]
	orr	r1 , #SCM_STR_MORDY
	beq wait_main_clock_stable
	
	/* PLLϥåȯԤߤ */
	ldr	r0 , =#PSW_TMR
	mov	r1 , #(PSW_TMR_PINC_MO | PSW_TMR_POWT_CONF7)	/* Ԥ֤Ϻͼ */
	str	r1 , [r0]
	
	/* PLLϰԤͭ */
	ldr	r0 , =#INT_ENR
	mov	r1 , #INT_CLL_PCS
	str	r1 , [r0]
	
	/* PLLʬΨ */
	ldr	r0 , =#PLL_CTL1		/* PLLK , PLLM */
	mov	r1 , #(PLL_CTL1_PLLK(PLLK_VALUE) | PLL_CTL1_PLLM(PLLM_VALUE))
	str	r1 , [r0]
	ldr	r0 , =#PLL_CTL2		/* PLLN */
	mov	r1 , #PLL_CTL2_PLLN(PLLN_VALUE)
	str	r1 , [r0]
	
	/* PLLư */
	ldr	r0 , =#SCM_CTL
	ldr	r1 , [r0]
	orr r1 , #SCM_CTL_PLLE
	str	r1 , [r0]
	
	/* PLLԤ */
	ldr	r0 , =#SCM_STR		/* APB2(8ʬ) */
  wait_pll_stable:
	ldr	r1 , [r0]
	and	r1 , #SCM_STR_PLRDY
	beq wait_pll_stable

	/* ޥåڤؤ */
	ldr	r0 , =#SCM_CTL
	ldr	r1 , [r0]
	and r1 , #~SCM_CTL_RCS_MASK
	orr r1 , #SCM_CTL_RCS_PLLCLK
	str	r1 , [r0]
	
	isb
	
	/* ȥ졼å */
	ldr	r0 , =#TTC_PSR				/* TTC(8ʬ) */
	mov	r1 , #(APB_CLK_DIV_8)
	str	r1 , [r0]
	
	/* ȥ졼ݡȤ */
	ldr	r0 , =#PFR0
	ldr	r1 , [r0]
	orr r1 , #(0x01F << 5)
	str	r1 , [r0]
	
	ldr	r0 , =#EPFR0
	ldr	r1 , [r0]
	orr r1 , #(0x03 << 24)
	str	r1 , [r0]
	
	bx	lr

